#ifndef COLOR_COLUMN_HPP
#define COLOR_COLUMN_HPP 1

#include <gtkmm.h>
#include <cellrenderercolor.hpp>

class ColorColumn : public Gtk::TreeViewColumn
{
	public:
		ColorColumn (const Glib::ustring& title, Gtk::TreeView* tree,
				     const Gtk::TreeModelColumn <Glib::ustring>& text_column,
				     const Gtk::TreeModelColumn < Glib::RefPtr<Gdk::Pixbuf> >& image_column
					 ) ;
		virtual ~ColorColumn () ;

//		ColorSignal& signal_color_changed (void) 
//		{ return m_colorSignal ; }

	private:
		Gtk::TreeView* m_tree_view ;

		Gtk::TreeModelColumn<Glib::ustring> m_text_column ;
		Gtk::TreeModelColumn< Glib::RefPtr<Gdk::Pixbuf> > m_image_column ;

		void change_color (const Glib::ustring& path, const Gdk::Color& c) ;
//		ColorSignal m_colorSignal ;
	protected:
		Gtk::CellRendererPixbuf* pixRend ;
		CellRendererColor* comboRend ;

} ;

#endif
