#include <mytree.hpp>
#include <colorcolumn.hpp>

//#include <boost/lambda/bind.hpp>
//using namespace boost::lambda ;

#include <iostream>
using namespace std ;

MyTree :: MyTree ()
	: Gtk::TreeView ()
{
	list_store = Gtk::ListStore::create (columns) ;
	set_model (list_store) ;
	set_rules_hint () ;
}

void MyTree :: on_realize (void)
{
	Gtk::TreeView::on_realize () ;

//	append_column_editable ("Boolean", columns.toggle) ;

	ColorColumn* comboCol = Gtk::manage(
			new ColorColumn("List Items", this, columns.list_option, columns.image)); 

//	comboCol->signal_color_changed().connect (boost::lambda::bind
//			(&MyTree :: change_color_for_column, this, _1, _2)) ;

	append_column (*comboCol) ;
}

#if 0
void MyTree :: change_color_for_column (const Glib::ustring& path, const Gdk::Color& c)
{
	Gtk::TreeIter iter = get_model()->get_iter (path) ;
	if (iter)
	{
		Gtk::TreeRow row = *iter ;
		row[columns.image] = create_from_color (c) ;
	}
}
#endif

void MyTree :: combo_renderer_edited (const Glib::ustring& path, const Glib::ustring& new_text)
{
	Gtk::TreeIter iter = get_model()->get_iter (path) ;
	if (iter)
	{
		Gtk::TreeRow row = *iter ;
		row[columns.list_option] = new_text ;
	}
}

Gtk::TreeModel::Row MyTree :: add_row (void)
{
	return *(list_store->append()) ;
}

void MyTree :: add_new_row (void)
{
	Gtk::TreeModel::Row row ;
	Gdk::Color c ;

	row = add_row() ;
	c.set_rgb_p (1.0, 0.5, 0.5) ;
	row[columns.toggle] = false ;
	row[columns.image] = create_from_color (c) ;
	row[columns.list_option] = "Red" ;
}

Glib::RefPtr<Gdk::Pixbuf> MyTree :: create_from_color (const Gdk::Color& c)
{
	int width (12), height (12) ;

	Glib::RefPtr<Gdk::Pixmap> pixmap = Gdk::Pixmap::create (
			get_window(), 
			width, 
			height
			) ;

	Cairo::RefPtr<Cairo::Context> context = pixmap->create_cairo_context() ;

	context->set_source_rgb (c.get_red_p(), c.get_green_p(), c.get_blue_p()) ;
	context->rectangle (0, 0, width, height) ;
	context->paint() ;

	Glib::RefPtr<Gdk::Image> image = pixmap->get_image(0, 0, width, height) ;
	Glib::RefPtr<Gdk::Pixbuf> pixbuf = Gdk::Pixbuf::create (
			image, 0, 0, width, height) ;

	return pixbuf ;
}

MyTree :: ~MyTree ()
{
}
