#ifndef MYTREE_HPP
#define MYTREE_HPP 1

#include <gtkmm.h>
#include <cellrenderercolor.hpp>

class MyTree : public Gtk::TreeView
{
	public:
		MyTree () ;
		~MyTree () ;

		void add_new_row (void) ;
		void combo_renderer_edited (const Glib::ustring& path, const Glib::ustring& new_text) ;
	protected:
		virtual void on_realize (void) ;
	private:
		struct Columns : public Gtk::TreeModel::ColumnRecord
		{
			Columns ()
			{
				add (image) ;
				add (toggle) ;
				add (list_option) ;
				add (list) ;
			}

			Gtk::TreeModelColumn<Glib::ustring> list_option ;
			Gtk::TreeModelColumn<bool> toggle ;
			Gtk::TreeModelColumn< Glib::RefPtr<Gdk::Pixbuf> > image ;
			Gtk::TreeModelColumn< Glib::RefPtr <Gtk::TreeModel> > list ;
		} ;

		Columns columns ;
		Glib::RefPtr<Gtk::ListStore> list_store ;

		Gtk::TreeModel::Row add_row (void);
		Glib::RefPtr<Gdk::Pixbuf> create_from_color (const Gdk::Color& c) ;

		void toggle_edit (Gtk::CellEditable*, const Glib::ustring&) ;
		void toggle_togl (const Glib::ustring&) ;
		void change_color_for_column (const Glib::ustring& path, const Gdk::Color& c) ;
} ;
#endif
