#include <mywindow.hpp>
#include <mytree.hpp>

#include <iostream>
using namespace std ;

MyWindow :: MyWindow ()
	: Gtk::Window ()
{
	set_title ("Cell Renderer Color") ;
	set_border_width(5);
	set_default_size(500, 300);

	Gtk::ScrolledWindow* swin = Gtk::manage (new Gtk::ScrolledWindow) ;
	Gtk::Box* mainbox = Gtk::manage (new Gtk::VBox (false, 5)) ;
	Gtk::ButtonBox *bottom = Gtk::manage (new Gtk::HButtonBox (Gtk::BUTTONBOX_SPREAD)) ;
	Gtk::Button* quit = Gtk::manage (new Gtk::Button (Gtk::Stock::QUIT)) ;
	Gtk::Button* addb = Gtk::manage (new Gtk::Button (Gtk::Stock::ADD)) ;

	swin->set_policy (Gtk::POLICY_AUTOMATIC, Gtk::POLICY_AUTOMATIC) ;
	swin->set_shadow_type (Gtk::SHADOW_IN) ;

	tree = Gtk::manage (new MyTree ()) ;
	swin->add (*tree) ;

	quit->signal_clicked().connect (sigc::mem_fun (*this, &Gtk::Window::hide)) ;
	addb->signal_clicked().connect (sigc::mem_fun (*tree, &MyTree::add_new_row)) ;

	bottom->add (*addb) ;
	bottom->add (*quit) ;
	mainbox->pack_start (*swin, true, true) ;
	mainbox->pack_start (*bottom, false, true) ;
	add (*mainbox) ;
	show_all_children () ;
}

MyWindow :: ~MyWindow ()
{
	cout << "My Window Destructor" << endl ;
}
